package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.keyareacheckrenovation.KeyAreaCheckRenovationDTO;
import cn.com.tenlion.systembase.pojo.vos.keyareacheckrenovation.KeyAreaCheckRenovationVO;
import cn.com.tenlion.systembase.service.keyareacheckrenovation.IKeyAreaCheckRenovationService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0013 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IKeyAreaCheckRenovationService keyAreaCheckRenovationService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0013() {}

    @KafkaListener(topics = "C0013FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<KeyAreaCheckRenovationDTO> keyAreaCheckRenovationDTOList = keyAreaCheckRenovationService.list(params);
        System.out.println(keyAreaCheckRenovationDTOList.size());
        if(null != keyAreaCheckRenovationDTOList && keyAreaCheckRenovationDTOList.size() > 0) {
            for(KeyAreaCheckRenovationDTO keyAreaCheckRenovationDTO: keyAreaCheckRenovationDTOList) {
                KeyAreaCheckRenovationVO keyAreaCheckRenovationVO = setData(keyAreaCheckRenovationDTO);
                keyAreaCheckRenovationService.saveKafka(keyAreaCheckRenovationDTO.getKeyAreaCheckRenovationId(), keyAreaCheckRenovationVO);
            }
        }
    }

    @KafkaListener(topics = "C0013")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            KeyAreaCheckRenovationDTO keyAreaCheckRenovationDTO = keyAreaCheckRenovationService.get(jsonObject.getString("uid"));
            KeyAreaCheckRenovationVO keyAreaCheckRenovationVO = setData(keyAreaCheckRenovationDTO);
            keyAreaCheckRenovationService.saveKafka(keyAreaCheckRenovationDTO.getKeyAreaCheckRenovationId(), keyAreaCheckRenovationVO);
        }else {
            keyAreaCheckRenovationService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private KeyAreaCheckRenovationVO setData(KeyAreaCheckRenovationDTO keyAreaCheckRenovationDTO) {
        if(null == keyAreaCheckRenovationDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        KeyAreaCheckRenovationVO keyAreaCheckRenovationVO = new KeyAreaCheckRenovationVO();
        keyAreaCheckRenovationVO.setSecurityArea(keyAreaCheckRenovationDTO.getSecurityArea());
        keyAreaCheckRenovationVO.setSecurityQuestionName(keyAreaCheckRenovationDTO.getSecurityQuestionName());
        keyAreaCheckRenovationVO.setInvolveAreaTypeName(keyAreaCheckRenovationDTO.getInvolveAreaTypeName());
        keyAreaCheckRenovationVO.setInvolveAreaRange(keyAreaCheckRenovationDTO.getInvolveAreaRange());
        keyAreaCheckRenovationVO.setLocationCode(keyAreaCheckRenovationDTO.getLocationCode());
        keyAreaCheckRenovationVO.setLongitude(keyAreaCheckRenovationDTO.getLongitude());
        keyAreaCheckRenovationVO.setLatitude(keyAreaCheckRenovationDTO.getLatitude());
        keyAreaCheckRenovationVO.setGrid(keyAreaCheckRenovationDTO.getGrid());
        return keyAreaCheckRenovationVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}